#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);

    int n;
    bool p1,p2,p3;
    unsigned long long
    cin >> n;
    vector<int> x(n), y(n);
    for(int i=0; i<n; i++){
        cin >> x[i] >> y[i];
    }
    if((x[0]==0&&y[0]==0))
    p1=true;
    if((x[1]==0&&y[1]==0))
    p2=true;
    if((x[2]==0&&y[2]==0))
    p3=true;

    rez=0;
    if(p1&&p2&&p3)
        cout << 7;
    else{
        if((p1&&p2)||(p2&&p3)||(p1&&p3))
        cout << 6;
        else{
            if(p1||p2||p3)
                cout << 4;
            else cout << rez;
        }
    }





    return 0;
}